<script>
import { AnsiUp } from 'ansi_up'
import { onBeforeUnmount, onMounted, ref } from 'vue'
import { useRoute } from 'vue-router'
import HeaderTemplate from '@/components/gitlab/pipeline/common/HeaderTemplate.vue'
import GitApi from '@/api/gitApi'

export default {
  name: 'JobLogsComponent',
  components: {
    HeaderTemplate,
  },
  props: {
    route: {
      type: String,
      default: 'vendors',
    },
  },
  setup(props) {
    const route = useRoute()
    const user = ref({})
    const groupId = ref(0)
    const projectId = ref(0)
    const jobId = ref(0)
    const project = ref({})
    const job = ref({ pipeline: {} })
    const logFileData = ref([])
    const ansi = new AnsiUp()
    let timer = null

    const logsList = computed(() => {
      const data = ansi.ansi_to_html(logFileData.value).split(/\n/gm)

      return data.map(value => value.replace(/^section_(end|start):[0-9,:,\w]+/gm, '')
        .replace('\r', ''))
    })

    const getJobLog = async () => {
      const git = new GitApi()
      try {
        const response = await git.getLog(projectId.value, jobId.value)

        logFileData.value = response.data
      }
      catch (error) {
        console.error('Error getting job log:', error)
      }
    }

    const getJob = async () => {
      const gitApi = new GitApi()
      try {
        const response = await gitApi.getJob(projectId.value, jobId.value)

        job.value = response.data
      }
      catch (error) {
        console.error('Error getting job:', error)
      }
    }

    const statusRequest = () => {
      timer = setInterval(() => {
        getJobLog()
      }, 5000)
    }

    const cancelAutoUpdate = () => {
      if (timer)
        clearInterval(timer)
    }

    const goBack = () => {
      window.history.back()
    }

    const scrollToTop = () => {
      window.scrollTo({ top: 0, behavior: 'smooth' })
    }

    const scrollToBottom = () => {
      window.scrollTo({ top: document.body.scrollHeight, behavior: 'smooth' })
    }

    onMounted(() => {
      user.value = store.state.user
      groupId.value = route.params.id
      projectId.value = route.params.project_id
      jobId.value = route.params.job_id
      getJob()
      getJobLog()
      statusRequest()
    })

    onBeforeUnmount(() => {
      cancelAutoUpdate()
    })

    return {
      user,
      groupId,
      projectId,
      jobId,
      project,
      job,
      logFileData,
      logsList,
      goBack,
      scrollToTop,
      scrollToBottom,
    }
  },
}
</script>

<template>
  <VCard>
    <HeaderTemplate
      :pipeline="job.pipeline"
      :group-id="groupId"
      :route="`${route}-pipeline-execution`"
      :project="project"
      :user="user"
    />

    <VCardText>
      <div class="job-log-content">
        <!-- Button to go back -->
        <VBtn
          color="primary"
          @click="goBack"
        >
          Back
        </VBtn>

        <div class="mt-2 mb-1">
          <h6>{{ job.name }}</h6>
        </div>
        <div class="mb-1">
          <small class="text-muted">Stage: {{ job.stage }}</small>
        </div>
        <div class="mb-1">
          <small class="text-muted">Duration: {{ formatDuration(job.duration) }}</small>
        </div>
        <div class="mb-1">
          <small class="text-muted">Finished {{ timeAgo(job.finished_at) }}</small>
        </div>

        <!-- Logs -->
        <div class="rounded console py-1">
          <div
            v-for="(inputs, index) in logsList"
            :key="index"
          >
            <div
              class="d-inline mx-1 index"
              v-html="index + 1"
            />
            <div
              class="d-inline overflow-x-auto my-0 console"
              v-html="inputs"
            />
          </div>
        </div>

        <!-- Floating button to scroll to top -->
        <VBtn
          class="back-to-top"
          color="primary"
          @click="scrollToTop"
        >
          <VIcon>mdi-arrow-up</VIcon>
        </VBtn>

        <!-- Floating button to scroll to bottom -->
        <VBtn
          class="back-to-bottom"
          color="primary"
          @click="scrollToBottom"
        >
          <VIcon>mdi-arrow-down</VIcon>
        </VBtn>
      </div>
    </VCardText>
  </VCard>
</template>

<style scoped>
.console {
  font-family: monospace;
  text-align: left;
  background-color: #111;
  color: #fff;
  white-space: pre-wrap;
}

.index {
  color: #6e6b7b;
  min-width: 4% !important;
  text-align: right;
}

/* Styles for the scroll to top button */
.back-to-top {
  position: fixed;
  right: 15px;
  top: 70%;
  padding: 5px;
  transform: translateY(-100%);
}

/* Styles for the scroll to bottom button */
.back-to-bottom {
  position: fixed;
  right: 15px;
  top: 70%;
  padding: 5px;
  transform: translateY(100%);
}
</style>
